#include "mplugin.h"

enginefuncs_t meta_engfuncs;           // Needed?!
enginefuncs_t g_engfuncs;              // Pointers to HL engine functions

meta_globals_t* gpMetaGlobals = NULL;  // Global variables struct from metamod
globalvars_t* gpGlobals = NULL;        // Global variables struct from the HL engine

DLL_FUNCTIONS gFunctionTable;          // Needed?

mutil_funcs_t* gpMetaUtilFuncs = NULL; // Metamod utility functions?
gamedll_funcs_t* gpGamedllFuncs = NULL;// Pointers to unhooked, unmodified mod functions?

// Plugin information struct
plugin_info_t Plugin_info = {
   META_INTERFACE_VERSION, // Metamod interface version
   THISPLUGIN_NAME,        // Plugin name
   THISPLUGIN_VERSION,     // Plugin version
   _COMPILETIME_,          // Date and time of compilation
   THISPLUGIN_AUTHOR,      // Plugin author
   THISPLUGIN_CONTACT,     // Author's contact ( email, website, ect... )
   THISPLUGIN_LOGTAG,      // Log tag?
   THISPLUGIN_LOADABLE,    // When can this plugin be loaded?
   THISPLUGIN_UNLOADABLE   // When can this plugin be unloaded?
};

// Mod API hooks
// Note:
// Macros really made this ugly, but still
// easier than before.
META_FUNCTIONS gMetaFunctionTable = {
   NULL, // TODO: Add GetEntityAPI
   NULL, // TODO: Add GetEntityAPI_Post
   #ifdef MHOOK_GETENTITYAPI2
   GetEntityAPI2,
   #else
   NULL,
   #endif
   #ifdef MHOOK_GETENTITYAPI2_POST
   GetEntityAPI2_Post
   #else
   NULL,
   #endif
   NULL, // TODO: Add GetNewDllFunctions
   NULL, // TODO: Add GetNewDllFunctions_Post
   #ifdef MHOOK_GETENGINEFUNCTIONS
   GetEngineFunctions,
   #else
   NULL,
   #endif
   #ifdef MHOOK_GETENGINEFUNCTIONS_POST
   GetEngineFunctions_Post
   #else
   NULL,
   #endif
};

   